︠f4881fc2-8724-4545-9085-3888416478d3i︠
%md
# Gram - Schmidt : deux exemples
## Rappel
Commençons par faire un rappel du procédé de Gramm - Schmidt. On devrait peut être dire *des* procedés de Gramm -Schmidt, l'un étant un procedé d'ortho**gonalisation** l'autre une procédé d'ortho**normalisation**. Aussi, prennons la convention de démarrer le procédé avec une famille linéairement indépendante de vecteurs. Ainsi, on peut énoncer :

### Procédé de Gram - Schmidt.
Soit $\cal{V}$ un espace vectoriel et $\{ \mathbf{u}_i\}_{i=1}^n$ une famille de vecteurs linéairement indépendants. On procède comme suit :

- On pose $\mathbf{f}_1 = \mathbf{u}_1$ et $\cal{W}_1 = {\sf Vect}(\mathbf{u}_1)$
- On pose $\mathbf{f}_2 = \mathbf{u}_2 - {\sf proj}_{{\cal W}_1}\mathbf{u_2}$ et $\cal{W}_2 = {\sf Vect}(\mathbf{f_1},\mathbf{f}_2)$ (ici on peut noter que $\cal{W}_2$ coïncide avec ${\sf Vect}(\mathbf{u_1},\mathbf{u}_2)$)
- On pose $\mathbf{f}_3 = \mathbf{u}_3 - {\sf proj}_{{\cal W}_2}\mathbf{u_3}$ et $\cal{W}_3 = {\sf Vect}(\mathbf{f_1},\mathbf{f}_2, \mathbf{f}_3)$
- $\cdots$

La famille des vecteurs $\{\mathbf{f}_i\}_{i=1}^n$ est une famille orthogonale. Pour le processus d'**orthogonalisation** on arrête ici.

Si on veut le procédé d'**orthonormalisation** on doit construire $\mathbf{v}_i = \frac{1}{||\mathbf{f}_i||}\mathbf{f}_i$.

︡ea280ca1-6666-4f00-ba3b-fabe8a4aca0c︡︡{"done":true,"md":"# Gram - Schmidt : deux exemples\n## Rappel\nCommençons par faire un rappel du procédé de Gramm - Schmidt. On devrait peut être dire *des* procedés de Gramm -Schmidt, l'un étant un procedé d'ortho**gonalisation** l'autre une procédé d'ortho**normalisation**. Aussi, prennons la convention de démarrer le procédé avec une famille linéairement indépendante de vecteurs. Ainsi, on peut énoncer :\n\n### Procédé de Gram - Schmidt.\nSoit $\\cal{V}$ un espace vectoriel et $\\{ \\mathbf{u}_i\\}_{i=1}^n$ une famille de vecteurs linéairement indépendants. On procède comme suit :\n\n- On pose $\\mathbf{f}_1 = \\mathbf{u}_1$ et $\\cal{W}_1 = {\\sf Vect}(\\mathbf{u}_1)$\n- On pose $\\mathbf{f}_2 = \\mathbf{u}_2 - {\\sf proj}_{{\\cal W}_1}\\mathbf{u_2}$ et $\\cal{W}_2 = {\\sf Vect}(\\mathbf{f_1},\\mathbf{f}_2)$ (ici on peut noter que $\\cal{W}_2$ coïncide avec ${\\sf Vect}(\\mathbf{u_1},\\mathbf{u}_2)$)\n- On pose $\\mathbf{f}_3 = \\mathbf{u}_3 - {\\sf proj}_{{\\cal W}_2}\\mathbf{u_3}$ et $\\cal{W}_3 = {\\sf Vect}(\\mathbf{f_1},\\mathbf{f}_2, \\mathbf{f}_3)$\n- $\\cdots$\n\nLa famille des vecteurs $\\{\\mathbf{f}_i\\}_{i=1}^n$ est une famille orthogonale. Pour le processus d'**orthogonalisation** on arrête ici.\n\nSi on veut le procédé d'**orthonormalisation** on doit construire $\\mathbf{v}_i = \\frac{1}{||\\mathbf{f}_i||}\\mathbf{f}_i$."}
︠5fab19da-412c-4721-9c37-983e17abfbeci︠
%md
### Remarque 1
Si on pose $\cal{W}={\sf Vect}(\{\mathbf{u}_i\})$ nous avons que :
- Les vecteurs $\mathbf{u}_i$ forment une **base** de $\cal{W}$,
- Les vecteurs $\mathbf{f}_i$ forment une **base orthogonale** de $\cal{W}$,
- Les vecteurs $\mathbf{v}_i$ forment une **base orthonormale** de $\cal{W}$.

### Remarque 2
On peut démarrer le procédé avec une famille infinie de vecteurs. On obtient alors :
- Les vecteurs $\mathbf{f}_i$ forment un **ensemble orthogonal** de vecteurs (pas nécessairement une base, au sens algébrique du terme).
- Les vecteurs $\mathbf{v}_i$ forment un **ensemble orthonormal** de vecteurs (pas nécessairement une base, au sens algébrique du terme).

La subtilité sera éclaircie quand nous traiterons des espaces de Hilbert.

### Remarque 3
La notion de projection se fait au moyen du produit scalaire. Or on a vu que dans un mème ensemble on peut définir différents produits scalaires. Les exemples qui suivent couvrent au moins deux contextes.
︡99dd1a52-e330-45fb-8e9e-76ea00ea49e9︡︡{"done":true,"md":"### Remarque 1\nSi on pose $\\cal{W}={\\sf Vect}(\\{\\mathbf{u}_i\\})$ nous avons que :\n- Les vecteurs $\\mathbf{u}_i$ forment une **base** de $\\cal{W}$,\n- Les vecteurs $\\mathbf{f}_i$ forment une **base orthogonale** de $\\cal{W}$,\n- Les vecteurs $\\mathbf{v}_i$ forment une **base orthonormale** de $\\cal{W}$.\n\n### Remarque 2\nOn peut démarrer le procédé avec une famille infinie de vecteurs. On obtient alors :\n- Les vecteurs $\\mathbf{f}_i$ forment un **ensemble orthogonal** de vecteurs (pas nécessairement une base, au sens algébrique du terme).\n- Les vecteurs $\\mathbf{v}_i$ forment un **ensemble orthonormal** de vecteurs (pas nécessairement une base, au sens algébrique du terme).\n\nLa subtilité sera éclaircie quand nous traiterons des espaces de Hilbert.\n\n### Remarque 3\nLa notion de projection se fait au moyen du produit scalaire. Or on a vu que dans un mème ensemble on peut définir différents produits scalaires. Les exemples qui suivent couvrent au moins deux contextes."}
︠bbd61c4b-011c-47ab-b4c7-7cf3ae83ad4ei︠
%md
### Exemple 1.
L'espace vectoriel est $\cal{V} = \mathbb{R}^3$ avec le produit scalaire *usuel*. On commence avec les vecteurs $\mathbf{u}_1 = (1,2,-2), \mathbf{u}_2 = (1,0,-4), \mathbf{u}_3 = (5,2,0)$. On va extraire une base orthogonale, puis une base orthonormale pour l'espace engendré par ces vecteurs. Comme le produit scalaire est le produit usuel, nous allons utiliser les commandes déjà présentes dans SAGEmath pour définir l'opération de projection.
︡115c6ba1-20bc-40ca-9f97-81dd5c36a65e︡︡{"done":true,"md":"### Exemple 1.\nL'espace vectoriel est $\\cal{V} = \\mathbb{R}^3$ avec le produit scalaire *usuel*. On commence avec les vecteurs $\\mathbf{u}_1 = (1,2,-2), \\mathbf{u}_2 = (1,0,-4), \\mathbf{u}_3 = (5,2,0)$. On va extraire une base orthogonale, puis une base orthonormale pour l'espace engendré par ces vecteurs. Comme le produit scalaire est le produit usuel, nous allons utiliser les commandes déjà présentes dans SAGEmath pour définir l'opération de projection."}
︠277b5e71-b0a6-4029-a931-275be48017eb︠
def proj(v,u):
	return u.dot_product(v)/u.dot_product(u)*u
︡ea947307-1733-48d4-8ecc-b04be1258ae6︡︡{"done":true}
︠e6dbd2c9-9e8e-45a2-9650-588eff6ea082︠
typeset_mode(True)
u1=vector([1,2,-2])
u2= vector([1,0,-4])
u3=vector([5,2,0])
︡92b6b7d7-3a62-4741-9878-0fd656e063c2︡︡{"done":true}
︠4e669975-1321-4716-9114-6f599e798b93︠
f1 = u1
︡de6a005d-84a3-4d2f-bd76-b63366deb6ea︡︡{"done":true}
︠eae35ffd-9ce2-4942-b918-1b9f54e11d9c︠
f2 = u2 - proj(u2, f1)
f2
︡7b8f619c-2ed1-4190-853d-70ce9bc29d88︡︡{"html":"<div align='center'>$\\displaystyle \\left(0,\\,-2,\\,-2\\right)$</div>","done":false}︡{"done":true}
︠12e13e6d-6c0f-419a-a72e-f9f858f07435︠
f3 = u3-proj(u3,f2)-proj(u3,f1)
f3
︡2d6e2c55-3b7d-4746-8836-00ac0cf05ca8︡︡{"html":"<div align='center'>$\\displaystyle \\left(4,\\,-1,\\,1\\right)$</div>","done":false}︡{"done":true}
︠a483981a-4ba9-4c84-baad-184289a610ba︠
v1 = f1.normalized()
v2 = f2.normalized()
v3 = f3.normalized()
v1
v2
v3
︡6e54c30f-76ae-4f41-a1c4-d7132ae11097︡︡{"html":"<div align='center'>$\\displaystyle \\left(\\frac{1}{3},\\,\\frac{2}{3},\\,-\\frac{2}{3}\\right)$</div>","done":false}︡{"html":"<div align='center'>$\\displaystyle \\left(0,\\,-\\frac{1}{2} \\, \\sqrt{2},\\,-\\frac{1}{2} \\, \\sqrt{2}\\right)$</div>","done":false}︡{"html":"<div align='center'>$\\displaystyle \\left(\\frac{2}{3} \\, \\sqrt{2},\\,-\\frac{1}{6} \\, \\sqrt{2},\\,\\frac{1}{6} \\, \\sqrt{2}\\right)$</div>","done":false}︡{"done":true}
︠79fa3647-3bee-4a2b-9034-8fd93c9ee16di︠
%md
### Exemple 2.
On reprend l'exemple vu en classe (les polynômes de Legendre). L'espace vectoriel est $\cal{V}=\mathbb{R}_{\leqslant 3}[x]$, c'est à dire les polynômes de degré au plus $3$ à coefficients réels. Le produit scalaire considéré cette fois est \[ \langle p | q\rangle = \int_{-1}^1 p(t)\cdot q(t)\ {\rm d}t\]
On commence avec la famille de vecteurs (polynômes) $\{1,x,x^2,x^3\}$ Posons $u_i(x) = x^i$ pour $i\in \{0,1,2,3\}$.

Cete fois on doit définir le produit scalaire à considérer. Une fois ceci fait, l'opération de projection suivra plutôt directement.

︡f298e146-7ab6-4500-ae17-a366fc639007︡︡{"done":true,"md":"### Exemple 2.\nOn reprend l'exemple vu en classe (les polynômes de Legendre). L'espace vectoriel est $\\cal{V}=\\mathbb{R}_{\\leqslant 3}[x]$, c'est à dire les polynômes de degré au plus $3$ à coefficients réels. Le produit scalaire considéré cette fois est \\[ \\langle p | q\\rangle = \\int_{-1}^1 p(t)\\cdot q(t)\\ {\\rm d}t\\]\nOn commence avec la famille de vecteurs (polynômes) $\\{1,x,x^2,x^3\\}$ Posons $u_i(x) = x^i$ pour $i\\in \\{0,1,2,3\\}$.\n\nCete fois on doit définir le produit scalaire à considérer. Une fois ceci fait, l'opération de projection suivra plutôt directement."}
︠2bae1805-ade5-419a-8598-fa26ee39fd19︠
def ps(p,q):
	return integrate(p(x)*q(x),x,-1,1)
︡0b05e67a-81ff-4e4d-90aa-9400b539eb3b︡︡{"done":true}
︠d6a33a91-51a6-4439-b201-974bd1a49657︠
def pproj(p,q):
	return ps(p,q)/ps(q,q)*q
︡da58fca7-0ee2-49ca-bbe0-95936d1c15de︡︡{"done":true}
︠dcdd2f66-7479-4480-ab37-f966bf6a58c1︠
u0(x) = 1
u1(x) = x
u2(x) = x^2
u3(x) = x^3
︡9e354dc5-aa5f-42de-ae86-ce5e0b833a36︡︡{"done":true}
︠a115355a-2b31-4b93-a582-285f5e9d7ab5︠
︠765a8a8d-dbe9-4e20-a507-3d6167af5595︠
f0(x) = u0(x)
f0(x)
︡edaa6096-fcb6-4d74-843c-6b9ae47fe9f4︡︡{"stdout":"1\n","done":false}︡{"done":true}
︠7582b400-3051-47be-9249-24652a8a5e9f︠

︡54f6f091-4d86-4cde-a7b7-9acc31bfcb97︡︡{"done":true}
︠6919e8c8-be2a-4cdc-bd64-d90fc1223ff9︠
f1(x) = u1- pproj(u1,f0)
f1(x)
︡db439ece-b0c3-463d-ac7d-add99e573eac︡︡{"stdout":"x\n","done":false}︡{"done":true}
︠156db35f-320e-4dcc-a9c1-43a699368043︠
f2(x) = u2 - pproj(u2,f0)- pproj(u2,f1)
f2(x)
︡b411ec6c-ee09-4062-86b6-f04d5e5a7e27︡︡{"stdout":"x^2 - 1/3\n","done":false}︡{"done":true}
︠b01728eb-7d93-4d85-b9f7-a3d876c70960︠
f3(x) = u3 - pproj(u3,f0)- pproj(u3,f1) - pproj(u3,f2)
f3(x)
︡71592f42-1ef4-4495-ba37-14b173c773b1︡︡{"stdout":"x^3 - 3/5*x\n","done":false}︡{"done":true}
︠6db5a1ab-943e-4bbf-8601-f524f9c46545i︠
%md
Les polynomes obtenus sont deux à deux orthogonaux. Normalisons-les maintenant.
︡54fe0a81-684e-4a8f-8ede-297a9934eb69︡︡{"done":true,"md":"Les polynomes obtenus sont deux à deux orthogonaux. Normalisons-les maintenant."}
︠0d0d6594-1b14-4da0-adf9-2473e37c6d9d︠
︡3dda5bed-7773-4042-ab51-e827c15c542e︡︡{"done":true}
︠6421136a-c87d-4edf-9493-744d6b77e4ac︠
v1(x) = f1(x)/ps(f1,f1)
v1(x)
︡eb1ae583-3128-4ac8-a110-71b9caa3b902︡︡{"html":"<div align='center'>$\\displaystyle \\frac{3}{2} \\, x$</div>","done":false}︡{"done":true}
︠8981d38c-f38d-4834-8e7f-e9dd0ab2fc4a︠
v2(x) = f2(x)/ps(f2,f2)
v2(x)
︡4d0960a9-47e2-4b17-9430-03706810bdb8︡︡{"html":"<div align='center'>$\\displaystyle \\frac{45}{8} \\, x^{2} - \\frac{15}{8}$</div>","done":false}︡{"done":true}
︠839a471d-1c0c-4e6e-a603-cce299991a59︠
v3(x) = f3(x)/ps(f3,f3)
v3(x)
︡f5d51b73-dc3b-437c-8dcb-f11c0a2ecfff︡︡{"html":"<div align='center'>$\\displaystyle \\frac{175}{8} \\, x^{3} - \\frac{105}{8} \\, x$</div>","done":false}︡{"done":true}
︠59b6788b-68e7-4713-a403-06375e59bb56︠









